
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Game_contentsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const game_contents = await db.game_contents.create(
            {
                id: data.id || undefined,
        
        launch_type: data.launch_type
        ||
        null
            ,
            
        redirect_url: data.redirect_url
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await game_contents.setProduct( data.product || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.game_contents.getTableName(),
                belongsToColumn: 'html_bundle',
                belongsToId: game_contents.id,
            },
            data.html_bundle,
            options,
        );
        

        return game_contents;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const game_contentsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                launch_type: item.launch_type
            ||
            null
            ,
            
                redirect_url: item.redirect_url
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const game_contents = await db.game_contents.bulkCreate(game_contentsData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < game_contents.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.game_contents.getTableName(),
                    belongsToColumn: 'html_bundle',
                    belongsToId: game_contents[i].id,
                },
                data[i].html_bundle,
                options,
            );
        }
        

        return game_contents;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const game_contents = await db.game_contents.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.launch_type !== undefined) updatePayload.launch_type = data.launch_type;
        
        
        if (data.redirect_url !== undefined) updatePayload.redirect_url = data.redirect_url;
        
        
        updatePayload.updatedById = currentUser.id;

        await game_contents.update(updatePayload, {transaction});

        
        
        if (data.product !== undefined) {
            await game_contents.setProduct(
              
              data.product,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.game_contents.getTableName(),
                belongsToColumn: 'html_bundle',
                belongsToId: game_contents.id,
            },
            data.html_bundle,
            options,
        );
        

        return game_contents;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const game_contents = await db.game_contents.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of game_contents) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of game_contents) {
                await record.destroy({transaction});
            }
        });


        return game_contents;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const game_contents = await db.game_contents.findByPk(id, options);

        await game_contents.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await game_contents.destroy({
            transaction
        });

        return game_contents;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const game_contents = await db.game_contents.findOne(
            { where },
            { transaction },
        );

        if (!game_contents) {
            return game_contents;
        }

        const output = game_contents.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.product = await game_contents.getProduct({
            transaction
        });
        
        
        output.html_bundle = await game_contents.getHtml_bundle({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.products,
        as: 'product',
        
        where: filter.product ? {
          [Op.or]: [
            { id: { [Op.in]: filter.product.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.product.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



      {
        model: db.file,
        as: 'html_bundle',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.redirect_url) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'game_contents',
                        'redirect_url',
                        filter.redirect_url,
                    ),
                };
            }
            

            
            

            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.launch_type) {
                where = {
                    ...where,
                launch_type: filter.launch_type,
            };
            }
            


      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.game_contents.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'game_contents',
                        'launch_type',
                        query,
                    ),
                ],
            };
        }

        const records = await db.game_contents.findAll({
            attributes: [ 'id', 'launch_type' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['launch_type', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.launch_type,
        }));
    }

    
};

